#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define FAST ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);cerr.tie(0)
#define mp make_pair
#define xx first
#define yy second
#define pb push_back
#define pf push_front
#define popb pop_back
#define popf pop_front
#define all(x) (x).begin(),(x).end()
#define inv(n) power((n), mod - 2)
#define ff(i,a,b) for (int (i) = (a); (i) < (b); (i)++)
#define fff(i,a,b) for (int (i) = (a); (i) <= b; (i)++)
#define bff(i,a,b) for (int (i) = (b)-1; (i) >= (a); (i)--)
#define bfff(i,a,b) for (int (i) = (b); (i) >= (a); (i)--)
#define sum_overflow(a,b) __builtin_add_overflow_p ((a), (b), (__typeof__ ((a) + (b))) 0)
#define mul_overflow(a,b) __builtin_mul_overflow_p ((a), (b), (__typeof__ ((a) + (b))) 0)

using namespace std;
long double typedef ld;
unsigned int typedef ui;
long long int typedef li;
pair<int,int> typedef pii;
pair<li,li> typedef pli;
pair<ld,ld> typedef pld;
vector<vector<int>> typedef graph;
unsigned long long int typedef ull;
//const int mod = 998244353;
const int mod = 1000000007;

using namespace __gnu_pbds;
template <class T> using oset = tree<T, null_type,less<T>, rb_tree_tag,tree_order_statistics_node_update>;
template <class T> using omset = tree<T, null_type,less_equal<T>, rb_tree_tag,tree_order_statistics_node_update>;







//Note to self: Check for overflow

int cnt[26];
int los=0;

void add(char c)
{
    cnt[c-'a']++;
    if (cnt[c-'a']==0) los--;
}

void rmv(char c)
{
    if (cnt[c-'a']==0) los++;
    cnt[c-'a']--;
}

int main()
{
    FAST;

    string s; cin>>s;
    int p=0,q=s.size()-1;
    while (s[p]==s[q] && p<q) p++,q--;
    if (p>=q) return cout<<1,0;

    int ans;
    int s1=(p+q)/2,s2=(p+q+1)/2;

    fff(i,p,s1) rmv(s[i]);
    fff(i,s1+1,q) add(s[i]);
    bfff(i,p,s1)
    {
        add(s[i]),add(s[i]);
        if (los==0) {ans=q-i+1;break;}
    }
    ff(i,0,26) cnt[i]=0; los=0;

    fff(i,s2,q) rmv(s[i]);
    fff(i,p,s2-1) add(s[i]);
    fff(i,s2,q)
    {
        add(s[i]),add(s[i]);
        if (los==0) {ans=min(ans,i-p+1);break;}
    }
    ff(i,0,26) cnt[i]=0; los=0;

    fff(i,p,s1) add(s[i]);
    fff(i,s2,q) rmv(s[i]);
    for (int L=s1,R=s2;;L--,R++)
    {
        if (s[L]!=s[R])
        {
            if (los==0) ans=min(ans,L-p+1);
            break;
        }
        rmv(s[L]),add(s[R]);
    }
    ff(i,0,26) cnt[i]=0; los=0;

    fff(i,s2,q) add(s[i]);
    fff(i,p,s1) rmv(s[i]);
    for (int L=s1,R=s2;;L--,R++)
    {
        if (s[L]!=s[R])
        {
            if (los==0) ans=min(ans,q-R+1);
            break;
        }
        add(s[L]),rmv(s[R]);
    }
    ff(i,0,26) cnt[i]=0; los=0;

    cout<<ans;
}

//Note to self: Check for overflow

/*

abcbxyyxcbba

abcbxyxycbba

abaxxdxcbxxycbyxdxxaba

*/